-- Exercice 1

data Ensemble a = E [a]
                  deriving (Show)

---- 1

estVide :: Ensemble a -> Bool
estVide (E []) = True
estVide _ = False 

---- 2

appartient :: (Ord a) => a -> Ensemble a -> Bool
appartient _ (E []) = False
appartient x (E (y:ys)) 
               |x==y = True
               |x<y = False
               |otherwise = appartient x (E ys)

---- 3

ajoute :: (Ord a) => a -> Ensemble a -> Ensemble a
ajoute x (E []) = (E [x])
ajoute x (E l@(y:ys))
    | x==y = (E l)
    | x<y = (E (x:l))
    | otherwise = E (y:ll)
    where (E ll) = ajoute x (E ys)

---- 4

intersection :: (Ord a) => Ensemble a -> Ensemble a -> Ensemble a

intersection (E l1) (E l2) = (E (intersectionL l1 l2))
    where intersectionL [] _ = []
          intersectionL _ [] = []
          intersectionL l3@(x:xs) l4@(y:ys)
              | x==y = (x:(intersectionL xs ys))
              | x<y = intersectionL xs l4 
              | otherwise = intersectionL l3 ys


---- 5

union (E l1) (E l2) = (E (unionL l1 l2))
    where unionL [] l = l
          unionL l [] = l
          unionL l3@(x:xs) l4@(y:ys)
              | x==y = (x:(unionL xs ys))
              | x<y = (x:(unionL xs l4))
              | otherwise = (y:(unionL l3 ys))

-- Exercice 2

---- 1

monReverse::[a]->[a]

monReverse l = monReverseT l []
    where monReverseT [] ll = ll
          monReverseT (x:xs) ll = monReverseT xs ll++[x]


---- 2 

nth::Int->[a]->a
nth 1 (x:xs) = x
nth n (x:xs) = nth (n-1) xs 

---- 3

sommeCarre::[Int]->Int
sommeCarre l = foldr (+) 0 (map (\x->x^2) l)

-- Exercice 3

mult1::Int->[Int]
mult1 n = [x*n|x<-[1..]]

mult2::Int->[Int]
mult2 n = map (*n) [1..]

mult3::Int->[Int]
mult3 n = zipWith (*) [1..] [n,n..]

mult4::Int->[Int]
mult4 n = filter (\x->(mod x n) == 0) [1..]

mult5::Int->[Int]
mult5 n = [n,2*n..]

mult6::Int->[Int]
mult6 n = mult6' 1 n
          where mult6' x y = (x*y:mult6' (x+1) y)

-- Exercice 4

crible::[Int]
crible = crible' [2..] 
    where crible' (x:xs) = x:(crible' (filter (\y->((mod y x)/=0)) xs))


-- Exercice 5

data BTree a = BNull | BNode a (BTree a) (BTree a)
             deriving (Show)

data NTree a = NNull | NNode a [NTree a]
             deriving (Show)

bTreeTest = (BNode 1 (BNode 2 (BNode 4 BNull BNull) BNull) (BNode 3 BNull BNull))

             
nbLeafB::(BTree a) -> Int
nbLeafB BNull = 0
nbLeafB (BNode _ BNull BNull) = 1
nbLeafB (BNode _ g d) = (nbLeafB g) + (nbLeafB d)

nbNodeB::(BTree a) -> Int
nbNodeB BNull = 0
nbNodeB (BNode _ BNull BNull) = 0
nbNodeB (BNode _ g d) = 1 + (nbNodeB g) + (nbNodeB d)

parcB::(BTree a) -> [a]
parcB BNull = []
parcB (BNode etiquette g d) =  [etiquette] ++ parcB(g) ++ parcB(d)

nbLeafN::(NTree a) -> Int 
nbLeafN NNull = 0
nbLeafN (NNode _ []) = 1
nbLeafN (NNode _ l) = foldr (+) 0 (map (nbLeafN) l)

nbNodeN::(NTree a) -> Int 
nbNodeN NNull = 0
nbNodeN (NNode _ []) = 0
nbNodeN (NNode _ l) = foldr (+) 1 (map (nbNodeN) l)

parcN::(NTree a) -> [a]
parcN NNull = []
parcN (NNode etiquette l) = foldr (++) [etiquette] (map (parcN) l) 





